/*-
 *  Copyright 2020 Beuth Hochschule für Technik Berlin, Hochschule für Technik Stuttgart
 * 
 *  This file is part of CityDoctor2.
 *
 *  CityDoctor2 is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  CityDoctor2 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with CityDoctor2.  If not, see <https://www.gnu.org/licenses/>.
 */
package de.hft.stuttgart.citydoctor2.math;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNull;

import org.junit.Test;

/**
 * 
 * @author Matthias Betz
 *
 */
public class LineTest {

	@Test
	public void testIntersection1() {
		Vector3d v0 = new Vector3d(-1, 0, 2);
		Vector3d v1 = new Vector3d(-1, 0, -2);
		Vector3d v2 = new Vector3d(1, 0, 0);
		
		Triangle3d t = new Triangle3d(v0, v1, v2);
		Line3d l = new Line3d(new Vector3d(0, 0, 0), new Vector3d(0, 1, 0));
		
		assertEquals(l.intersection(t), new Vector3d(0, 0, 0));
	}
	
	@Test
	public void testIntersection2() {
		Vector3d v0 = new Vector3d(-1, 0, 2);
		Vector3d v1 = new Vector3d(-1, 0, -2);
		Vector3d v2 = new Vector3d(1, 0, 0);
		
		Triangle3d t = new Triangle3d(v0, v1, v2);
		Line3d l = new Line3d(new Vector3d(0, 1, 0), new Vector3d(0, 1, 0));
		
		assertEquals(l.intersection(t), new Vector3d(0, 0, 0));
	}
	
	@Test
	public void testIntersection3() {
		Vector3d v0 = new Vector3d(-1, 0, 2);
		Vector3d v1 = new Vector3d(-1, 0, -2);
		Vector3d v2 = new Vector3d(1, 0, 0);
		
		Triangle3d t = new Triangle3d(v0, v1, v2);
		Line3d l = new Line3d(new Vector3d(2, 1, 0), new Vector3d(0, 1, 0));
		
		assertNull(l.intersection(t));
	}
}
